# LayoutUnit

LayoutUnit represents a region in the border layout model of the Layout component.

> Layout and LayoutUnit are deprecated, use  [FlexGrid](https://www.primefaces.org/showcase/ui/panel/flexGrid.xhtml) or [GridCSS](/components/gridcss.md) instead.


## Info

| Name | Value |
| - | - |
| Tag | layoutUnit
| Component Class | org.primefaces.component.layout.LayoutUnit
| Component Type | org.primefaces.component.LayoutUnit
| Component Family | org.primefaces.component |
| Renderer Type | org.primefaces.component.LayoutUnitRenderer
| Renderer Class | org.primefaces.component.layout.LayoutUnitRenderer

## Attributes

| Name | Default | Type | Description | 
| --- | --- | --- | --- |
id | null | String | Unique identifier of the component
rendered | true | Boolean | Boolean value to specify the rendering of the component, when set to false component will not be rendered.
binding | null | Object | An el expression that maps to a server side UIComponent instance in a backing bean
position | null | String | Position of the unit.
size | null | String | Size of the unit.
resizable | false | Boolean | Makes the unit resizable.
closable | false | Boolean | Makes the unit closable.
collapsible | false | Boolean | Makes the unit collapsible.
header | null | String | Text of header.
footer | null | String | Text of footer.
minSize | null | Integer | Minimum dimension for resize.
maxSize | null | Integer | Maximum dimension for resize.
gutter | 4px | String | Gutter size of layout unit.
visible | true | Boolean | Specifies default visibility
collapsed | false | Boolean | Specifies toggle status of unit
collapseSize | null | Integer | Size of the unit when collapsed
style | null | String | Inline style of the component.
styleClass | null | String | Style class of the component.
effect | null | String | Effect name of the layout transition.
effectSpeed | null | String | Effect speed of the layout transition.

## Getting started with LayoutUnit
See layout component documentation for more information regarding the usage of layoutUnits.

## Facets
In addition to _header_ and _footer_ attributes to display text at these locations, facets are also provided
with the same name to display custom content.

